 
N = 1000 #number of individuals
M = 2000 #number of SNPs

Fst = 0.16
#ancestral minor allele freq
tmafs = array(0.5,M)
  
#minor allele freq at each pair of SNPs
tmafs1= tmafs2 = 0
for (i in 1:M) {
	tmafs1[i] = rbeta(1,tmafs[i]*(1-Fst)/Fst,(1-tmafs[i])*(1-Fst)/Fst)
    tmafs2[i] = rbeta(1,tmafs[i]*(1-Fst)/Fst,(1-tmafs[i])*(1-Fst)/Fst)
}

#haplotypes of each individual at each pair of SNPs
genos1 = matrix(0,nrow=N,ncol=M);
genos2 = matrix(0,nrow=N,ncol=M);
for(i in 1:N) {
    genos1[i,]=rbinom(M,2,tmafs1) 
    genos2[i,]=rbinom(M,2,tmafs2) 
}


mafs1 = apply(genos1,2,mean)/2
mafs2 = apply(genos2,2,mean)/2
mafs = (mafs1+mafs2)/2

genos = rbind(genos1,genos2)

for (i in 1:20) {
g = genos[,i] 
Ns = 2*N 

p = mean(g)/2
q = 1-p

e2 = p^2*Ns
e1 = 2*p*q*Ns
e0 = q^2*Ns

o2 = sum(g==2)
o1 = sum(g==1)
o0 = sum(g==0)

chiHW = (o2-e2)^2/e2 + (o1-e1)^2/e1 + (o0-e0)^2/e0
print(sprintf("HW %f",chiHW))
}

#HW only works without population structure