source("./reml_func.R")
N = 500 #number of individuals
M = 100 #number of SNPs
h2 = 0.5

h2est = 0
for (iter in 1:10) {
freqs = runif(M,0.05,0.95)

#genotypes of each individual
genos = matrix(0,nrow=N,ncol=M);
for(i in 1:N) {
    genos[i,]=rbinom(M,2,freqs) 
}


mafs = apply(genos,2,mean)/2
zgenos = matrix(0,nrow=N,ncol=M)
for (i in 1:(N)) {
        zgenos[i,] = (genos[i,]-2*mafs)/sqrt(2*mafs*(1-mafs))
}

KG = zgenos%*%t(zgenos)/(M)

betas = rnorm(M,0,sqrt(h2/M))
phenosg = genos%*%betas 
phenos=phenosg+rnorm(N,0,sqrt(var(phenosg)*(1/h2-1))) #add noise to get h2 as specified above

Kt=list()

Kt[[1]] = KG
res1 <- aiREML(Kt,phenos,array(1,N),c(0.5,0.5),verbose=F)
h2est[iter] = res1$vars[1]/sum(res1$vars)
print(sprintf("%d %f %f",iter,h2est[iter],mean(h2est)))
}