 
N = 1000 #number of individuals
M = 10000 #number of SNPs

Fst = 0.1
#ancestral minor allele freq
tmafs = array(0.5,M)
  
#minor allele freq at each pair of SNPs
tmafs1= tmafs2 = 0
for (i in 1:M) {
	tmafs1[i] = rbeta(1,tmafs[i]*(1-Fst)/Fst,(1-tmafs[i])*(1-Fst)/Fst)
    tmafs2[i] = rbeta(1,tmafs[i]*(1-Fst)/Fst,(1-tmafs[i])*(1-Fst)/Fst)
}

#haplotypes of each individual at each pair of SNPs
genos1 = matrix(0,nrow=N,ncol=M);
genos2 = matrix(0,nrow=N,ncol=M);
for(i in 1:N) {
    genos1[i,]=rbinom(M,2,tmafs1) 
    genos2[i,]=rbinom(M,2,tmafs2) 
}


mafs1 = apply(genos1,2,mean)/2
mafs2 = apply(genos2,2,mean)/2
mafs = (mafs1+mafs2)/2

genos = rbind(genos1,genos2)
zgenos = matrix(0,nrow=2*N,ncol=M)
for (i in 1:(2*N)) {
        zgenos[i,] = (genos[i,]-2*mafs)/sqrt(2*mafs*(1-mafs))
}
fzgenos = zgenos[, !is.na(apply(zgenos,2,mean))]

W = (fzgenos%*%t(fzgenos))/ncol(fzgenos)
e = eigen(W)

beta = 0.2
pop = c(array(0,N),array(1,N))
pheno = rnorm(2*N)+pop*beta
chis = 0
chis2 = 0
for (i in 1:M) {
	chis[i] = cor(genos[,i],pheno)^2*(2*N)
	chis2[i] = summary(lm(pheno~genos[,i]+e$vectors[,1]))$coef[2,3]^2
}

lambdaGC = median(chis)/0.454
lambdaGC2 = median(chis2)/0.454

pvs = 1-pchisq(chis,1)
pvs2 = 1-pchisq(chis2,1)
obsLogPvs = sort(-log10(pvs))
obsLogPvs2 = sort(-log10(pvs2))
expLogPvs = sort(-log10(seq(1/M,1,1/M)))

tstr = sprintf("qqplot Fst:%f lambdaGC:%f",Fst,lambdaGC)
plot(expLogPvs,obsLogPvs,main=tstr)
points(expLogPvs,obsLogPvs2,col="red")
lines(c(0,10),c(0,10))