 
N = 500 #number of individuals
M = 1000 #number of SNPs

freqs = runif(M,0.05,0.95)

#genotypes of each individual
genos = matrix(0,nrow=N,ncol=M);
for(i in 1:N) {
    genos[i,]=rbinom(M,2,freqs) 
}

pheno = rnorm(N)
pv=0
for (i in 1:M) {
	res <- lm(pheno~genos[,i])
	pv[i] = summary(res)$coef[2,4]
}
hist(pv)
#power is a function of beta, minor allele frequency, and sample size

#premutation test
opv = pv
minp = 0
for (p in 1:1000) {
	rpheno = pheno[sample(1:N,N)]
	pv=0
	for (i in 1:M) {
		res <- lm(rpheno~genos[,i])
		pv[i] = summary(res)$coef[2,4]
	}
	minp[p]=min(pv)
	print(sprintf("%d %f %f %f",p,min(opv),minp[p],sum(minp<min(opv))/p))
}

#if we did this in a real GWAS data set of COMMMON variants we get pvt ~ 5e-8 the 5% threshold of min-p-values