 
N = 1000 #number of individuals
M = 10000 #number of SNPs

freqs = runif(M,0.05,0.95)

#genotypes of each individual
genos = matrix(0,nrow=N,ncol=M);
for(i in 1:N) {
    genos[i,]=rbinom(M,2,freqs) 
}

pheno = rnorm(N)
chis = 0
for (i in 1:M) {
	chis[i] = cor(genos[,i],pheno)^2*N
}

lambdaGC = median(chis)/0.454

pvs = 1-pchisq(chis,1)
obsLogPvs = sort(-log10(pvs))
expLogPvs = sort(-log10(seq(1/M,1,1/M)))

tstr = sprintf("qqplot lambdaGC:%f",lambdaGC)
plot(expLogPvs,obsLogPvs,main=tstr)
lines(c(0,10),c(0,10))